import org.json.simple.JSONObject;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.lang.StringBuilder;
/**
* Класс описывающий сущность Person
*/
public class Person implements Essence, Address, EssenceWithDocs {
   String docID;
   List<String> rowKeys;
   String middlename;
   String lastname;
   String firstname;
   String birthdate;
   String birthyear;
   List<String> phone;
   private List<String> addressValue;
   List<String> addressNormal;
   Docs docs;
   List<String> ip;
   List<String> domain;
   List<String> dbKeys;
   Person() {
       docID = null;
       rowKeys = new ArrayList<>();
       middlename = null;
       lastname = null;
       firstname = null;
       birthdate = null;
       birthyear = null;
       phone = new ArrayList<>();
       //accounts = new Accounts();
       addressValue = new ArrayList<>();
       addressNormal = new ArrayList<>();
       docs = new Docs();
       ip = new ArrayList<>();
       domain = new ArrayList<>();
       dbKeys = new ArrayList<>();
   }
   void TrySetBirthdate(String birthdate) {
       DateFormat f = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
       try {
           this.birthdate = f.format(f.parse(birthdate));
       } catch (Exception e) {
           e.printStackTrace();
       }
   }
   void TrySetBirthdate(JSONObject birthdate) {
       Object year = birthdate.get("year");
       Object month = birthdate.get("month");
       Object day = birthdate.get("day");
       if (year != null && month != null && day != null) {
           StringBuilder dateStr = new StringBuilder();
           dateStr.append(year);
           dateStr.append("-");
           dateStr.append(month);
           dateStr.append("-");
           dateStr.append(day);
           dateStr.append("T00:00:00");
           DateFormat f = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
           try {
               this.birthdate = f.format(f.parse(dateStr.toString()));
           } catch (Exception e) {
               e.printStackTrace();
           }
       }
   }
   void TrySetMiddlename(JSONObject jsonObject) {
       String tmp = "";
       if (jsonObject.containsKey("value")) {
           tmp += jsonObject.get("value");
       }
       if (jsonObject.containsKey("trash")) {
           tmp += jsonObject.get("trash");
       }
       if (!"".equals(tmp)) {
           this.middlename = tmp;
       }
   }
   public void TrySetAddress(JSONObject jsonObject) {
       if (jsonObject.containsKey("value")) {
           String tmp = jsonObject.get("value").toString();
           if (!this.addressValue.contains(tmp)) {
               this.addressValue.add(tmp);
           }
       }
   }
   public void TrySetDocSN(String sn) {
       this.docs.TrySetDocSN(sn);
   }
   public void TrySetDocType(String type) {
       this.docs.TrySetDocType(type);
   }
   public void TrySetDoc(String type, String sn) {
       this.docs.TrySetDoc(type, sn);
   }
   public String getDocID() {
       return this.docID;
   }

   public void setDocID(String newDocID) {
       this.docID = newDocID;
   }
   public List<String> getRowKeys() {
       return this.rowKeys;
   }
   public boolean isEmpty() {
       return (middlename == null && firstname == null && lastname == null && birthdate == null && birthyear == null)
               && (phone.size() == 0 && addressValue.size() == 0 && ip.size() == 0 && domain.size() == 0)
               && docs.isEmpty();//&& accounts.isEmpty()
   }
   public void Merge(Essence essence) {
       Person p = ((Person) essence);
       if (this.firstname == null && p.firstname != null)
           this.firstname = p.firstname;
       if (this.middlename == null && p.middlename != null)
           this.middlename = p.middlename;
       if (this.lastname == null && p.lastname != null)
           this.lastname = p.lastname;
       if (this.birthdate == null && p.birthdate != null)
           this.birthdate = p.birthdate;
       if (this.birthyear == null && p.birthyear != null)
           this.birthyear = p.birthyear;
       for (String onePhone : p.phone) {
           if (!this.phone.contains(onePhone))
               this.phone.add(onePhone);
       }
       for (String address : p.addressValue) {
           if (!this.addressValue.contains(address))
               this.addressValue.add(address);
       }
       for (String addressNormal : p.addressNormal) {
           if (!this.addressNormal.contains(addressNormal))
               this.addressNormal.add(addressNormal);
       }
       this.docs.Merge(p.docs);
       for (String oneIP : p.ip) {
           if (!this.ip.contains(oneIP))
               this.ip.add(oneIP);
       }
       for (String oneDomain : p.domain) {
           if (!this.domain.contains(oneDomain))
               this.domain.add(oneDomain);
       }
       for (String oneDbKey : p.dbKeys) {
           if (!this.dbKeys.contains(oneDbKey))
               this.dbKeys.add(oneDbKey);
       }
       this.rowKeys.addAll(p.rowKeys);
       try {
           if (Long.parseLong(this.docID) > Long.parseLong(p.docID))
               this.docID = p.docID;
       } catch (Exception e) {
       }
   }
   public String toString() {
       StringBuilder tmp = new StringBuilder();
       tmp.append("{");
       tmp.append("\"doc_id\":\"").append(this.docID).append("\"");
       if (this.firstname != null)
         tmp.append(",\"firstname\":\"").append(MyFunctions.normalizeForJSON(this.firstname)).append("\"");
       if (this.middlename != null)
           tmp.append(",\"middlename\":\"").append(MyFunctions.normalizeForJSON(this.middlename)).append("\"");
       if (this.lastname != null)
           tmp.append(",\"lastname\":\"").append(MyFunctions.normalizeForJSON(this.lastname)).append("\"");
       if (this.birthdate != null)
           tmp.append(",\"birthdate\":\"").append(this.birthdate).append("\"");
       if (this.birthyear != null)
           tmp.append(",\"birthyear\":\"").append(MyFunctions.normalizeForJSON(this.birthyear)).append("\"");
       if (this.phone.size() != 0) {
           tmp.append(",");
           tmp.append(MyFunctions.arrayStringToString("phone", this.phone));
       }
       if (this.addressValue.size() != 0 || this.addressNormal.size() != 0) {
           tmp.append(",");
           tmp.append(MyFunctions.arrayAddressToString(this.addressValue, this.addressNormal));
       }
       if (!this.docs.isEmpty()) {
           tmp.append(",");
           tmp.append(this.docs);
       }
       if (this.ip.size() != 0) {
           tmp.append(",");
           tmp.append(MyFunctions.arrayStringToString("ip", this.ip));
       }
       if (this.domain.size() != 0) {
           tmp.append(",");
           tmp.append(MyFunctions.arrayStringToString("domain", this.domain));
       }
       tmp.append(",").append(MyFunctions.arrayStringToString("row_keys", this.rowKeys));
       tmp.append(",").append(MyFunctions.arrayStringToString("db_key", this.dbKeys));
       tmp.append("}");//"}"
       return tmp.toString();
   }
   public String getCSVtoNeo4j() {
       StringBuilder tmp = new StringBuilder();
       tmp.append(docID);
       tmp.append("\001");
       if (this.firstname != null)
           tmp.append("\"").append(MyFunctions.normalizeForJSON(this.firstname)).append("\"");
       tmp.append("\001");
       if (this.middlename != null)
           tmp.append("\"").append(MyFunctions.normalizeForJSON(this.middlename)).append("\"");
       tmp.append("\001");
       if (this.lastname != null)
           tmp.append("\"").append(MyFunctions.normalizeForJSON(this.lastname)).append("\"");
       tmp.append("\001");
       if (this.birthdate != null)
           tmp.append("\"").append(MyFunctions.normalizeForJSON(this.birthdate)).append("\"");
       tmp.append("\001");
       if (this.birthyear != null)
           tmp.append("\"").append(MyFunctions.normalizeForJSON(this.birthyear)).append("\"");
       tmp.append("\001");
       tmp.append(MyFunctions.arrayToCSV(this.phone));
       tmp.append("\001");
       tmp.append(MyFunctions.arrayToCSV(this.addressValue));
       tmp.append("\001");
       tmp.append(MyFunctions.arrayToCSV(this.addressNormal));
       tmp.append("\001");
       tmp.append(MyFunctions.arrayToCSV(this.domain));
       tmp.append("\001");
       tmp.append(MyFunctions.arrayToCSV(this.ip));
       tmp.append("\001");
       tmp.append(this.docs.forCSV());
       tmp.append(MyFunctions.arrayToCSV(this.rowKeys));
       tmp.append("\001");
       tmp.append(MyFunctions.arrayToCSV(this.dbKeys));
       return tmp.toString();
   }
   public String getJSONtoPropertiesNeo4j() {
       StringBuilder tmp = new StringBuilder();
       tmp.append("MATCH (n:Person { docID: {two} }) SET n=");
       tmp.append("{");
       tmp.append("docID:\"").append(this.docID).append("\"");
       if (this.firstname != null)
           tmp.append(",firstname:\"").append(MyFunctions.normalizeForJSON(this.firstname)).append("\"");
       if (this.middlename != null)
           tmp.append(",middlename:\"").append(MyFunctions.normalizeForJSON(this.middlename)).append("\"");
       if (this.lastname != null)
           tmp.append(",lastname:\"").append(MyFunctions.normalizeForJSON(this.lastname)).append("\"");
       if (this.birthdate != null)
           tmp.append(",birthdate:\"").append(this.birthdate).append("\"");
       //tmp.append(String.format("\"birthdate\":\"%s\",\n", this.birthdate));
       if (this.birthyear != null)
           tmp.append(",birthyear:\"").append(MyFunctions.normalizeForJSON(this.birthyear)).append("\"");
       tmp.append(",");
       tmp.append(MyFunctions.arrayStringToStringForNeo4j("rowKeys", this.rowKeys));
       if (this.phone.size() != 0) {
           tmp.append(",");
           tmp.append(MyFunctions.arrayStringToStringForNeo4j("phone", this.phone));
       }
       if (this.addressValue.size() != 0) {
           tmp.append(",");
           tmp.append(MyFunctions.arrayStringToStringForNeo4j("addressValue", this.addressValue));
       }
       if (this.addressNormal.size() != 0) {
           tmp.append(",");
           tmp.append(MyFunctions.arrayStringToStringForNeo4j("addressNormal", this.addressNormal));
       }
       if (!this.docs.isEmpty()) {
           tmp.append(",");
           tmp.append(this.docs.forJSONtoNeo4j());
       }
       if (this.ip.size() != 0) {
           tmp.append(",");
           tmp.append(MyFunctions.arrayStringToStringForNeo4j("ip", this.ip));
       }
       if (this.domain.size() != 0) {
           tmp.append(",");
           tmp.append(MyFunctions.arrayStringToStringForNeo4j("domain", this.domain));
       }
       tmp.append(",");
       tmp.append(MyFunctions.arrayStringToStringForNeo4j("dbKeys", this.dbKeys));
       tmp.append("};");
       return tmp.toString();
   }
}